//Sketch written by Vicky Metzen
//Feel free to copy (as i have done as well)
//Made with Processing 2.1
//In order to run, make sure you have following libraries installed:
//have fun :)



import java.util.Iterator;
import controlP5.*;
import peasy.*;
import plethora.core.*;
import toxi.geom.*;

import saito.objloader.*;

ControlP5 cp5;
ControlWindow controlWindow;

PeasyCam cam;

OBJModel model ;

Spline3D sp2;
Spline3D sp3;
Spline3D sp4;
Spline3D sp5;
Spline3D sp6;
Spline3D sp7;

Spline3D sp8;
Spline3D sp9;

int Attractor = 100; //what does this number mean? will it overwrite itself??

int buttonValue = 10;
int Boids_BK =  10;
int Boids_DSC = 10;
int Boids_CLIMATOR = 10;
int Boids_Group_7 = 10;
int Boids_Group_5 = 10;
int Boids_Group_4 = 10;
float strenght_BK = 0.5;
float strenght_DSC = 0.5;
float strenght_CLIMATOR = 0.5;
float strenght_Group_4 = 0.5;
float strenght_Group_5 = 0.5;
float strenght_Group_7 = 0.5;
float strenght_roof = 0.5;
float strenght_stage = 0.5;
int Thickness = 2;
int Speed = 6;
int Textfont = 24;




float Distance = 0.5;
int Roof = 100;

boolean bStop;


ArrayList <Ple_Agent> boids;
ArrayList <Ple_Agent> boids2;
ArrayList <Ple_Agent> boids3;
ArrayList <Ple_Agent> boids4;
ArrayList <Ple_Agent> boids5;
ArrayList <Ple_Agent> boids6;

float DIMX = 600;
float DIMY = 600;
float DIMZ = 600;

//int pop = Boidnum;

PVector l;

PFont f;

void setup() {
  size(1200, 600, P3D);
  smooth();
  

  f = createFont("Arial",16,true);


  model = new OBJModel(this, "pointobj.obj", "absolute");//TRIANGLES
  model.enableDebug();

  model.scale(2);
  model.translateToCenter();
  model.disableMaterial();

  cam = new PeasyCam(this, 0, 0, 0, 800);
  cam.lookAt(0, 0, 0);
  

  //output = createWriter("data/points.csv");



  boids = new ArrayList <Ple_Agent>();
  for (int i = 0; i < Boids_BK; i++) {
    //set the initial location as 0,0,0
    Vec3D v = new Vec3D (-300, 200, 0); //////change start here!!!!
    //create the plethora agents!
    Ple_Agent pa = new Ple_Agent(this, v);
    //generate a random initial velocity
    Vec3D initialVelocity = new Vec3D (0, 0, 0);
    //set some initial values:
    //initial velocity
    pa.setVelocity(initialVelocity);
    //initialize the tail
    pa.initTail(5);
    //add the agents to the list
    boids.add(pa);
  }

  boids2 = new ArrayList <Ple_Agent>();
  for (int i = 0; i < Boids_DSC; i++) {
    //set the initial location as 0,0,0
    Vec3D v = new Vec3D (300, 300, 0);
    //create the plethora agents!
    Ple_Agent pa = new Ple_Agent(this, v);
    //generate a random initial velocity
    Vec3D initialVelocity = new Vec3D (0, 0, 0);
    //set some initial values:
    //initial velocity
    pa.setVelocity(initialVelocity);
    //initialize the tail
    pa.initTail(5);
    //add the agents to the list
    boids2.add(pa);
  }

  boids3 = new ArrayList <Ple_Agent>();
  for (int i = 0; i < Boids_CLIMATOR; i++) {
    //set the initial location as 0,0,0
    Vec3D v = new Vec3D (-200, -400, 0);
    //create the plethora agents!
    Ple_Agent pa = new Ple_Agent(this, v);
    //generate a random initial velocity
    Vec3D initialVelocity = new Vec3D (0, 0, 0);
    //set some initial values:
    //initial velocity
    pa.setVelocity(initialVelocity);
    //initialize the tail
    pa.initTail(5);
    //add the agents to the list
    boids3.add(pa);
  }

  boids4 = new ArrayList <Ple_Agent>();
  for (int i = 0; i < Boids_Group_7; i++) {
    //set the initial location as 0,0,0
    Vec3D v = new Vec3D (150, -150, 70);
    //create the plethora agents!
    Ple_Agent pa = new Ple_Agent(this, v);
    //generate a random initial velocity
    Vec3D initialVelocity = new Vec3D (0, 0, 0);
    //set some initial values:
    //initial velocity
    pa.setVelocity(initialVelocity);
    //initialize the tail
    pa.initTail(5);
    //add the agents to the list
    boids4.add(pa);
  }

  boids5 = new ArrayList <Ple_Agent>();
  for (int i = 0; i < Boids_Group_7; i++) {
    //set the initial location as 0,0,0
    Vec3D v = new Vec3D ( -250, -50, 0);
    //create the plethora agents!
    Ple_Agent pa = new Ple_Agent(this, v);
    //generate a random initial velocity
    Vec3D initialVelocity = new Vec3D (0, 0, 0);
    //set some initial values:
    //initial velocity
    pa.setVelocity(initialVelocity);
    //initialize the tail
    pa.initTail(5);
    //add the agents to the list
    boids5.add(pa);
  }

  boids6 = new ArrayList <Ple_Agent>();
  for (int i = 0; i < Boids_Group_7; i++) {
    //set the initial location as 0,0,0
    Vec3D v = new Vec3D ( -100, 150, 100);
    //create the plethora agents!
    Ple_Agent pa = new Ple_Agent(this, v);
    //generate a random initial velocity
    Vec3D initialVelocity = new Vec3D (0, 0, 0);
    //set some initial values:
    //initial velocity
    pa.setVelocity(initialVelocity);
    //initialize the tail
    pa.initTail(5);
    //add the agents to the list
    boids6.add(pa);
  }

  ////////Splines that act as attractors:

  sp2 = new Spline3D();
  sp3 = new Spline3D();
  sp4 = new Spline3D();
  sp5 = new Spline3D();
  sp6 = new Spline3D();
  sp7 = new Spline3D();

  sp8 = new Spline3D();
  sp9 = new Spline3D();




  ////Location of prey is connected to swarm 0,0,0):

  for (int i = 0; i < 20; i ++) {
    Vec3D v = new Vec3D( -300, 200, 0); ////Entrance science
    sp2.add(v);
  }

  for (int i = 0; i < 20; i ++) {
    Vec3D v = new Vec3D( 300, 300, 0); ////Entrance bk
    sp3.add(v);
  }

  for (int i = 0; i < 20; i ++) {
    Vec3D v = new Vec3D( -250, -50, 0);  ///Group 4
    sp4.add(v);
  }


  for (int i = 0; i < 20; i ++) {
    Vec3D v = new Vec3D( 150, -150, 70);  ///Group 7 
    sp5.add(v);
  }

  for (int i = 0; i < 20; i ++) {
    Vec3D v = new Vec3D( -100, 150, 100); ////Group 5 
    sp6.add(v);
  }

  for (int i = 0; i < 20; i ++) {
    Vec3D v = new Vec3D( -200, -400, 0); ////Entrance climator
    sp7.add(v);
  }

  for (int i = 0; i < 20; i ++) {
    Vec3D v = new Vec3D( 0, 0, 150); ////roof //200, 100 stable
    sp8.add(v);
  }

  for (int i = 0; i < 20; i ++) {
    Vec3D v = new Vec3D( 0, 0, -150); ////audi //200,100 stable
    sp9.add(v);
  }

  /////Control P5:

  cp5 = new ControlP5(this);

  cp5.addSlider("Boids_BK")
    .setPosition(20, 80)
      .setRange(1, 40)
        ; 

  cp5.addSlider("Boids_DSC")
    .setPosition(20, 100)
      .setRange(1, 40)
        ; 

  cp5.addSlider("Boids_CLIMATOR")
    .setPosition(20, 120)
      .setRange(1, 40)
        ;    

  cp5.addSlider("Boids_Group_7")
    .setPosition(20, 140)
      .setRange(1, 40)
        ;   

  cp5.addSlider("Boids_Group_5")
    .setPosition(20, 160)
      .setRange(1, 40)
        ;          

  cp5.addSlider("Boids_Group_4")
    .setPosition(20, 180)
      .setRange(1, 40)
        ;   

  cp5.addSlider("Distance")
    .setPosition(20, 40)
      .setRange(0.1, 5)
        ; 
        
  cp5.addSlider("Thickness")
    .setPosition(20, 20)
      .setRange(1, 10)
        ;
       
  cp5.addSlider("Textfont")
    .setPosition(20, 220)
      .setRange(0, 24)
        ;  
        
        
  

  cp5.addButton("RESET")
    .setValue(100)
      .setPosition(20, 560)
        .setSize(60, 20)    
          ;
  
  cp5.addButton("Press 'p' to pause")
    .setValue(100)
      .setPosition(20, 460)
        .setSize(60, 0)    
          ;   
     
  cp5.addButton("Press 'l' to play")
    .setValue(100)
      .setPosition(20, 480)
        .setSize(60, 0)    
          ;   
 
 cp5.addButton("Press 's' to print screen")
    .setValue(100)
      .setPosition(20, 500)
        .setSize(60, 0)    
          ; 
       
  cp5.addButton("Press 'c' to reset camera")
    .setValue(100)
      .setPosition(20, 520)
        .setSize(60, 0)    
          ;    
          
          
  cp5.addSlider("strenght_BK")
    .setPosition(20, 260)
      .setRange(0.1, 5)   
        ;

  cp5.addSlider("strenght_DSC")
    .setPosition(20, 280)
      .setRange(0.1, 5)   
        ;

  cp5.addSlider("strenght_CLIMATOR")
    .setPosition(20, 300)
      .setRange(0.1, 5)   
        ;

  cp5.addSlider("strenght_Group_7")
    .setPosition(20, 320)
      .setRange(0.1, 5)   
        ;

  cp5.addSlider("strenght_Group_5")
    .setPosition(20, 340)
      .setRange(0.1, 5)   
        ;  

  cp5.addSlider("strenght_Group_4")
    .setPosition(20, 360)
      .setRange(0.1, 5)   
        ; 
    
  cp5.addSlider("strenght_roof")
    .setPosition(20, 380)
      .setRange(0.1, 5)   
        ;  
    
  cp5.addSlider("strenght_stage")
    .setPosition(20, 400)
      .setRange(0.1, 5)   
        ;      

  cp5.setAutoDraw(false);  //so it floats!!
}

void draw() {

  /*println(Roof);
   for (int i = 0; i < 20; i ++) {
   //sp8[i].loc.z=Roof;
   Vec3D v1 = sp8.pointlist.get(i);
   }*/
  

  background(0); 
 
  
  pushMatrix();
  
 
  textFont(f,Textfont);
  fill(255);
  text("BK",320,320);
  text("CLIMATOR",-420,250);
  text("DSC",-220,-420);
  text("Group 7",240,-170);
  text("Group 4",-360,-50);
  text("Group 5",-140,220);

  strokeWeight(0.5);
  stroke(100);
  noFill();
  model.draw();
  gui();
 
  /////The Attractors/Swarm///

  /////// Entrance science /////////////////////////////////////////////////////

  for (Ple_Agent pa : boids) {


    //call flock, cohesion, alignment, separation.
    //first define the population, then the distances for cohesion,alignment, 
    //separation and then the scales in same order. Try playing with the scales and distances!
    pa.flock(boids, 10, 100, 10, 0.1, 0.5, 0.1); // 20, 100, 50 , 1, 0.5, 0.1);

    //call a separation function to keep distance between agents
    pa.separationCall(boids, 10, Distance);//SEPERATION!!! and duration?    -> letzte zahl hat einfluss auf seperation!


    pa.spiral2D(10, 10, 50); /////CHANGE HERE!!!! Radius, distance, angle

    //calculate future location at 50 units
    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    //calculate closest normal to spline //STILL IN PROGRESS
    //use the mouse to change the direction

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp2, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    //follow point obtained from spline

    pa.seek(cns, strenght_CLIMATOR); //strenght of attractor////////////////////////////////////////////////////////////////

    //define the boundries of the space:
    pa.wrapSpace(DIMX, DIMY, DIMY);

    //update the tail info every frame (1)
    pa.updateTail(1);



    //display the tail interpolating 2 sets of values:
    //R,G,B,ALPHA,SIZE - R,G,B,ALPHA,SIZE
    //pa.displayTailPoints(0, 0, 0, 20,  0.1,   0, 0, 0, 20, 0.1);

    //set the max speed of movement:
    pa.setMaxspeed(Speed);
    //pa.setMaxforce(0.05);

    //define population, and ranges for the line
    //pa.drawLinesInRange(boids, 1, 50);

    //update agents location based on past calculations
    pa.update();

    //define population, and ranges for the line
    //pa.drawLinesInRange(boids, 1, 50);
    //pa.drawLinesBetweenTails(boids, 20,50);
    //Display the location of the agent with a point
    pa.dropTrail(2, 10000);

    stroke(0, 200, 255, 100);
    strokeWeight(Thickness);
    pa.drawTrail(20);

    strokeWeight(1);
    stroke(255);
    pa.displayPoint();

    //Display the direction of the agent with a line
    /*strokeWeight(1);
     stroke(100,90);
     pa.displayDir(pa.vel.magnitude()*3);*/
  }

  /////Entrance bk ///////////////////////////////////////////
  for (Ple_Agent pa : boids) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke (255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp3, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_BK); //strenght of attractor

    pa.displayPoint();
  }
  ////Group 4///////////////////////////////////////////
  for (Ple_Agent pa : boids) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp4, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_Group_4); //strenght of attractor

    pa.displayPoint();
  }
  ////Group 7 ///////////////////////////////////////////
  for (Ple_Agent pa : boids) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp5, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_Group_7); //strenght of attractor

    pa.displayPoint();
  }

  ////Group 5///////////////////////////////////////////
  for (Ple_Agent pa : boids) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp6, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_Group_5); //strenght of attractor

    pa.displayPoint();
  }

  ////Entrance climator///////////////////////////////////////////
  for (Ple_Agent pa : boids) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp7, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_DSC); //strenght of attractor

    pa.displayPoint();
  }

  ////roof///////////////////////////////////////////
  for (Ple_Agent pa : boids) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp8, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_roof); //strenght of attractor

    pa.displayPoint();
  }


  ////audi//////////////////////////////////////////
  for (Ple_Agent pa : boids) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp9, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_stage); //strenght of attractor

    pa.displayPoint();
  }

  //// I tried expoerting the points like this- it gives me an error, because of course the agents are not static..

  /*if(keyPressed){
   
   println("Printed!");
   
   //output.println( Ple_Agent.loc.x + "," + Ple_Agent.y + "," + Ple_Agent.z);
   
   output.flush();
   output.close();
   
   }*/


  for (Ple_Agent pa : boids2) {



    pa.flock(boids2, 10, 100, 10, 0.1, 0.5, 0.1); // 20, 100, 50 , 1, 0.5, 0.1);
    pa.separationCall(boids2, 10, Distance);//SEPERATION!!! and duration?    -> letzte zahl hat einfluss auf seperation! erst pop
    pa.spiral2D(10, 10, 50); /////CHANGE HERE!!!! Radius, distance, angle

    //calculate future location at 50 units
    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp2, fLoc, 0);
    stroke(255, 255, 255, 20);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_CLIMATOR); //strenght of attractor////////////////////////////////////////////////////////////////

    pa.wrapSpace(DIMX, DIMY, DIMY);

    pa.updateTail(1);

    pa.setMaxspeed(Speed);



    pa.update();

    pa.dropTrail(2, 10000);

    stroke(0, 175, 255, 100);
    strokeWeight(Thickness);
    pa.drawTrail(20);

    strokeWeight(1);
    stroke(255);
    pa.displayPoint();
  }

  /////Entrance bk_swarm2 ///////////////////////////////////////////
  for (Ple_Agent pa : boids2) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke (255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp3, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_BK); //strenght of attractor

    pa.displayPoint();
  }
  ////Group 4_swarm 2//////////////////////////////////////////
  for (Ple_Agent pa : boids2) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp4, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_Group_4); //strenght of attractor

    pa.displayPoint();
  }
  ////Group 7_swarm 2 ///////////////////////////////////////////
  for (Ple_Agent pa : boids2) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp5, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_Group_7); //strenght of attractor

    pa.displayPoint();
  }

  ////Group 5_swarm 2///////////////////////////////////////////
  for (Ple_Agent pa : boids2) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp6, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_Group_5); //strenght of attractor

    pa.displayPoint();
  }

  ////Entrance climator_swarm 2///////////////////////////////////////////
  for (Ple_Agent pa : boids2) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp7, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_DSC); //strenght of attractor

    pa.displayPoint();
  }

  ////roof_swarm 2///////////////////////////////////////////
  for (Ple_Agent pa : boids2) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp8, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_roof); //strenght of attractor

    pa.displayPoint();
  }


  ////audi_swarm 2//////////////////////////////////////////
  for (Ple_Agent pa : boids2) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp9, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_stage); //strenght of attractor

    pa.displayPoint();
  }

  for (Ple_Agent pa : boids3) {



    pa.flock(boids3, 10, 100, 10, 0.1, 0.5, 0.1); // 20, 100, 50 , 1, 0.5, 0.1);
    pa.separationCall(boids3, 10, Distance);//SEPERATION!!! and duration?    -> letzte zahl hat einfluss auf seperation! erst pop
    pa.spiral2D(10, 10, 50); /////CHANGE HERE!!!! Radius, distance, angle

    //calculate future location at 50 units
    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp2, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_CLIMATOR); //strenght of attractor////////////////////////////////////////////////////////////////

    pa.wrapSpace(DIMX, DIMY, DIMY);

    pa.updateTail(1);

    pa.setMaxspeed(Speed);

    pa.update();

    pa.dropTrail(2, 10000);

    stroke(0, 255, 255, 100);
    strokeWeight(Thickness);
    pa.drawTrail(20);

    strokeWeight(1);
    stroke(255);
    pa.displayPoint();
  }

  /////Entrance bk_swarm3 ///////////////////////////////////////////
  for (Ple_Agent pa : boids3) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke (255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp3, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_BK); //strenght of attractor

    pa.displayPoint();
  }
  ////Group 4_swarm 3//////////////////////////////////////////
  for (Ple_Agent pa : boids3) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp4, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_Group_4); //strenght of attractor

    pa.displayPoint();
  }
  ////Group 7_swarm 3 ///////////////////////////////////////////
  for (Ple_Agent pa : boids3) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp5, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_Group_7); //strenght of attractor

    pa.displayPoint();
  }

  ////Group 5_swarm 3///////////////////////////////////////////
  for (Ple_Agent pa : boids3) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp6, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_Group_5); //strenght of attractor

    pa.displayPoint();
  }

  ////Entrance climator_swarm 3///////////////////////////////////////////
  for (Ple_Agent pa : boids3) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp7, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_DSC); //strenght of attractor

    pa.displayPoint();
  }

  ////roof_swarm 3///////////////////////////////////////////
  for (Ple_Agent pa : boids3) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp8, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_roof); //strenght of attractor

    pa.displayPoint();
  }


  ////audi_swarm 3//////////////////////////////////////////
  for (Ple_Agent pa : boids3) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp9, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_stage); //strenght of attractor

    pa.displayPoint();
  }

  //////////////FOUR/////////////////////////

  for (Ple_Agent pa : boids4) {

    pa.flock(boids4, 10, 100, 10, 0.1, 0.5, 0.1); // 20, 100, 50 , 1, 0.5, 0.1);
    pa.separationCall(boids4, 10, Distance);//SEPERATION!!! and duration?    -> letzte zahl hat einfluss auf seperation! erst pop
    pa.spiral2D(10, 10, 50); /////CHANGE HERE!!!! Radius, distance, angle

    //calculate future location at 50 units
    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp2, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_CLIMATOR); //strenght of attractor////////////////////////////////////////////////////////////////

    pa.wrapSpace(DIMX, DIMY, DIMY);

    pa.updateTail(1);

    pa.setMaxspeed(Speed);



    pa.update();

    pa.dropTrail(2, 10000);

    stroke(255, 150, 0, 100);
    strokeWeight(Thickness);
    pa.drawTrail(20);

    strokeWeight(1);
    stroke(255);
    pa.displayPoint();
  }

  /////Entrance bk_swarm 4 ///////////////////////////////////////////
  for (Ple_Agent pa : boids4) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke (255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp3, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_BK); //strenght of attractor

    pa.displayPoint();
  }
  ////Group 4_swarm 4//////////////////////////////////////////
  for (Ple_Agent pa : boids4) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp4, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_Group_4); //strenght of attractor

    pa.displayPoint();
  }
  ////Group 7_swarm 4 ///////////////////////////////////////////
  for (Ple_Agent pa : boids4) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp5, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_Group_7); //strenght of attractor

    pa.displayPoint();
  }

  ////Group 5_swarm 4///////////////////////////////////////////
  for (Ple_Agent pa : boids4) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp6, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_Group_5); //strenght of attractor

    pa.displayPoint();
  }

  ////Entrance climator_swarm 4///////////////////////////////////////////
  for (Ple_Agent pa : boids4) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp7, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_DSC); //strenght of attractor

    pa.displayPoint();
  }

  ////roof_swarm 4///////////////////////////////////////////
  for (Ple_Agent pa : boids4) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp8, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_roof); //strenght of attractor

    pa.displayPoint();
  }


  ////audi_swarm 4//////////////////////////////////////////
  for (Ple_Agent pa : boids4) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp9, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_stage); //strenght of attractor

    pa.displayPoint();
  }

  /////////FIVE///////////////////

  for (Ple_Agent pa : boids5) {

    pa.flock(boids4, 10, 100, 10, 0.1, 0.5, 0.1); // 20, 100, 50 , 1, 0.5, 0.1);
    pa.separationCall(boids5, 10, Distance);//SEPERATION!!! and duration?    -> letzte zahl hat einfluss auf seperation! erst pop
    pa.spiral2D(10, 10, 50); /////CHANGE HERE!!!! Radius, distance, angle

    //calculate future location at 50 units
    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp2, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_CLIMATOR); //strenght of attractor////////////////////////////////////////////////////////////////

    pa.wrapSpace(DIMX, DIMY, DIMY);

    pa.updateTail(1);

    pa.setMaxspeed(Speed);

    pa.update();

    pa.dropTrail(2, 10000);

    stroke(255, 200, 0, 100);
    strokeWeight(Thickness);
    pa.drawTrail(20);

    strokeWeight(1);
    stroke(255);
    pa.displayPoint();
  }

  /////Entrance bk_swarm5 ///////////////////////////////////////////
  for (Ple_Agent pa : boids5) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke (255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp3, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_BK); //strenght of attractor

    pa.displayPoint();
  }
  ////Group 4_swarm 5//////////////////////////////////////////
  for (Ple_Agent pa : boids5) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp4, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_Group_4); //strenght of attractor

    pa.displayPoint();
  }
  ////Group 7_swarm 5 ///////////////////////////////////////////
  for (Ple_Agent pa : boids5) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp5, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_Group_7); //strenght of attractor

    pa.displayPoint();
  }

  ////Group 5_swarm 5///////////////////////////////////////////
  for (Ple_Agent pa : boids5) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp6, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_Group_5); //strenght of attractor

    pa.displayPoint();
  }

  ////Entrance climator_swarm 5///////////////////////////////////////////
  for (Ple_Agent pa : boids5) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp7, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_DSC); //strenght of attractor

    pa.displayPoint();
  }

  ////roof_swarm 5///////////////////////////////////////////
  for (Ple_Agent pa : boids5) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp8, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_roof); //strenght of attractor

    pa.displayPoint();
  }


  ////audi_swarm 5//////////////////////////////////////////
  for (Ple_Agent pa : boids5) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp9, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_stage); //strenght of attractor

    pa.displayPoint();
  }

  /////////////SIX/////////////////////////////////////////////

  for (Ple_Agent pa : boids6) {

    pa.flock(boids4, 10, 100, 10, 0.1, 0.5, 0.1); // 20, 100, 50 , 1, 0.5, 0.1);
    pa.separationCall(boids6, 10, Distance);//SEPERATION!!! and duration?    -> letzte zahl hat einfluss auf seperation! erst pop
    pa.spiral2D(10, 10, 50); /////CHANGE HERE!!!! Radius, distance, angle

    //calculate future location at 50 units
    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp2, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_CLIMATOR); //strenght of attractor////////////////////////////////////////////////////////////////

    pa.wrapSpace(DIMX, DIMY, DIMY);

    pa.updateTail(1);

    pa.setMaxspeed(Speed);

    strokeWeight(2);
    stroke(255, 200);

    pa.update();

    pa.dropTrail(2, 10000);

    stroke(255, 175, 0, 100);
    strokeWeight(Thickness);
    pa.drawTrail(20);

    strokeWeight(1);
    stroke(255);
    pa.displayPoint();
  }

  /////Entrance bk_swarm 6 ///////////////////////////////////////////
  for (Ple_Agent pa : boids6) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke (255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp3, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_BK); //strenght of attractor

    pa.displayPoint();
  }
  ////Group 4_swarm 6//////////////////////////////////////////
  for (Ple_Agent pa : boids6) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp4, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_Group_4); //strenght of attractor

    pa.displayPoint();
  }
  ////Group 7_swarm 6 ///////////////////////////////////////////
  for (Ple_Agent pa : boids6) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp5, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_Group_7); //strenght of attractor

    pa.displayPoint();
  }

  ////Group 5_swarm 6///////////////////////////////////////////
  for (Ple_Agent pa : boids6) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp6, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_Group_5); //strenght of attractor

    pa.displayPoint();
  }

  ////Entrance climator_swarm 6///////////////////////////////////////////
  for (Ple_Agent pa : boids6) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp7, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_DSC); //strenght of attractor

    pa.displayPoint();
  }

  ////roof_swarm 6///////////////////////////////////////////
  for (Ple_Agent pa : boids6) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp8, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_roof); //strenght of attractor

    pa.displayPoint();
  }


  ////audi_swarm 6//////////////////////////////////////////
  for (Ple_Agent pa : boids6) {


    Vec3D fLoc = pa.futureLoc(10);
    stroke(255, 255, 255, 5);
    pa.vLine(fLoc, pa.loc);  

    Vec3D cns = pa.closestNormalandDirectionToSpline(sp9, fLoc, 0);
    stroke(255, 255, 255, 5);
    pa.vLine(cns, fLoc);

    pa.seek(cns, strenght_stage); //strenght of attractor

    pa.displayPoint();
  }


 

  popMatrix();
  
  
if (keyPressed) {
  
  if (key == 's') {

  saveFrame("images/artwork-####.jpg");
  }
}
  
}

void gui() {
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  cp5.draw();
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
}

void RESET()
{


  boids = new ArrayList <Ple_Agent>();
  for (int i = 0; i < Boids_CLIMATOR; i++) {
    //set the initial location as 0,0,0
    Vec3D v = new Vec3D (-300, 200, 0); //////change start here!!!!
    //create the plethora agents!
    Ple_Agent pa = new Ple_Agent(this, v);
    //generate a random initial velocity
    Vec3D initialVelocity = new Vec3D (0, 0, 0);
    //set some initial values:
    //initial velocity
    pa.setVelocity(initialVelocity);
    //initialize the tail
    pa.initTail(5);
    //add the agents to the list
    boids.add(pa);
  }

  boids2 = new ArrayList <Ple_Agent>();
  for (int i = 0; i < Boids_BK; i++) {
    //set the initial location as 0,0,0
    Vec3D v = new Vec3D (300, 300, 0);
    //create the plethora agents!
    Ple_Agent pa = new Ple_Agent(this, v);
    //generate a random initial velocity
    Vec3D initialVelocity = new Vec3D (0, 0, 0);
    //set some initial values:
    //initial velocity
    pa.setVelocity(initialVelocity);
    //initialize the tail
    pa.initTail(5);
    //add the agents to the list
    boids2.add(pa);
  }

  boids3 = new ArrayList <Ple_Agent>();
  for (int i = 0; i < Boids_DSC; i++) {
    //set the initial location as 0,0,0
    Vec3D v = new Vec3D (-200, -400, 0);
    //create the plethora agents!
    Ple_Agent pa = new Ple_Agent(this, v);
    //generate a random initial velocity
    Vec3D initialVelocity = new Vec3D (0, 0, 0);
    //set some initial values:
    //initial velocity
    pa.setVelocity(initialVelocity);
    //initialize the tail
    pa.initTail(5);
    //add the agents to the list
    boids3.add(pa);
  }

  boids4 = new ArrayList <Ple_Agent>();
  for (int i = 0; i < Boids_Group_7; i++) {
    //set the initial location as 0,0,0
    Vec3D v = new Vec3D (150, -150, 70);
    //create the plethora agents!
    Ple_Agent pa = new Ple_Agent(this, v);
    //generate a random initial velocity
    Vec3D initialVelocity = new Vec3D (0, 0, 0);
    //set some initial values:
    //initial velocity
    pa.setVelocity(initialVelocity);
    //initialize the tail
    pa.initTail(5);
    //add the agents to the list
    boids4.add(pa);
  }

  boids5 = new ArrayList <Ple_Agent>();
  for (int i = 0; i < Boids_Group_4; i++) {
    //set the initial location as 0,0,0
    Vec3D v = new Vec3D ( -250, -50, 0);
    //create the plethora agents!
    Ple_Agent pa = new Ple_Agent(this, v);
    //generate a random initial velocity
    Vec3D initialVelocity = new Vec3D (0, 0, 0);
    //set some initial values:
    //initial velocity
    pa.setVelocity(initialVelocity);
    //initialize the tail
    pa.initTail(5);
    //add the agents to the list
    boids5.add(pa);
  }

  boids6 = new ArrayList <Ple_Agent>();
  for (int i = 0; i < Boids_Group_5; i++) {
    //set the initial location as 0,0,0
    Vec3D v = new Vec3D ( -100, 150, 100);
    //create the plethora agents!
    Ple_Agent pa = new Ple_Agent(this, v);
    //generate a random initial velocity
    Vec3D initialVelocity = new Vec3D (0, 0, 0);
    //set some initial values:
    //initial velocity
    pa.setVelocity(initialVelocity);
    //initialize the tail
    pa.initTail(5);
    //add the agents to the list
    boids6.add(pa);
  }
}

void keyPressed(){
  
  if (key == 'c' ) {
  cam.reset();
  }
  
  if (key == 'p' ) {
  noLoop();
  
  }
  if (key == 'l' ) {
  loop();
  }
  
}

/*void PAUSE()  {
  noLoop();
}

void PLAY()  {
  loop();
}*/


   

















